/**************************************************************

File Name:		FIR_bccoeff.asm
		
Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1 Silicon
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SEGMENT syntax

Description:	Program to call FIR.asm in coeficient broadcast mode

**************************************************************/
#include "def21364.h"
#define SAMPLES 512
#define TAPS 	64

.EXTERN fir, fir_init;

.SECTION/PM seg_pmda;
.VAR    coefs[TAPS] = "coeffs.dat";   /* FIR coefficient stored in file    */
.VAR    outbuf[2*SAMPLES];


.SECTION/DM seg_dmda;
.VAR    dline[2*TAPS];                    


.SECTION/DM seg_dmda;
.VAR    inbuf[2*SAMPLES]="indata1.dat";  		/* multichannel input data array */


.SECTION/PM    seg_rth;
Reserved_1:		rti; nop; nop; nop;
Chip_Reset:		idle; jump begin; nop; nop;
	


.SECTION/PM seg_pmco;
begin:  l1=0;				/* initialize for modulo addressing */
        l2=l1;
        l0=2*TAPS;			/* initialize delay line circular buffer */
        l8=l0;
		l9=TAPS;			/* initialize coeficient broadcast circular buffer */	
        m0=2;				/* initialize modifiers */
        m8=m0;
		m1=1;
		m9=1;				/* coeficient broadcast modifier */
        r1=TAPS-3;			/* setup loop count registers */
		r2=SAMPLES;			
    	r5=TAPS;			/* delayline intialization register */
		call fir_init (db); /* function call to zero the delay line */
		b0=dline;			/* pointer to delay line */	
	   	b9=coefs;			/* pointer to coeficient array */ 
filt:	call fir (db);		/* function call to fir filter routine */
		b1=inbuf;			/* pointer to input array */
		b10=outbuf;			/* pointer to output array */
done:   jump filt;
		nop;
		nop;
		

